'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _themes = require('./themes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Local loading state is managed by caller;
 */
var LocalLoading = function (_PureComponent) {
  _inherits(LocalLoading, _PureComponent);

  function LocalLoading() {
    _classCallCheck(this, LocalLoading);

    return _possibleConstructorReturn(this, (LocalLoading.__proto__ || Object.getPrototypeOf(LocalLoading)).apply(this, arguments));
  }

  _createClass(LocalLoading, [{
    key: 'getContainer',
    value: function getContainer() {
      // eslint-disable-next-line react/no-find-dom-node
      var dom = (0, _reactDom.findDOMNode)(this);
      if (dom instanceof HTMLElement) {
        var parent = dom.parentNode;
        if (parent instanceof HTMLElement) {
          return parent;
        }
      }
      throw new Error('Local loading DOM is inaccessible');
    }
  }, {
    key: 'createLoadingBox',
    value: function createLoadingBox(container) {
      var masked = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      this.box = document.createElement('div');
      // console.error('masked', masked);
      this.box.setAttribute('class', masked ? _styles2.default.localMasked : _styles2.default.local);
      if (!masked) {
        var computedStyles = window.getComputedStyle ? window.getComputedStyle(container) : container.currentStyle;
        if (computedStyles.position === 'static') {
          container.style.position = 'relative';
        }
      }
      if (this.box) {
        container.appendChild(this.box);
      }
    }
  }, {
    key: 'renderLoading',
    value: function renderLoading(props) {
      // console.log('Theme', Theme);
      if (!this.box) return;
      var Theme = props.theme || _themes.Blobs;
      (0, _reactDom.render)(_react2.default.createElement(Theme, _extends({}, props, { active: !!props.active })), this.box);
    }
  }, {
    key: 'display',
    value: function display(active, button) {
      if (active) {
        if (this.box) {
          this.box.style.visibility = 'visible';
          if (active !== true) {
            active._canceled = true;
          }
        }
        if (button) {
          button.classList.add('disabled');
          button.setAttribute('disabled', 'disabled');
        }
      } else {
        if (this.box) {
          this.box.style.visibility = 'hidden';
        }
        if (button) {
          button.classList.remove('disabled');
          button.removeAttribute('disabled');
        }
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // initial container
      var active = nextProps.active,
          button = nextProps.button,
          message = nextProps.message,
          masked = nextProps.masked,
          theme = nextProps.theme;
      var container = nextProps.container;

      var toRenderLoading = void 0;
      if (container !== this.props.container) {
        if (this.box) {
          this.destroy();
        }
        if (container == undefined) {
          // eslint-disable-line eqeqeq
          container = this.getContainer();
        }
        if (container instanceof HTMLElement) {
          this.createLoadingBox(container, masked);
          toRenderLoading = true;
        }
      } else if (this.box && masked !== this.props.masked) {
        this.box.setAttribute('class', masked ? _styles2.default.localMasked : _styles2.default.local);
      }

      // render box content
      if (toRenderLoading || this.box && (active !== this.props.active || message !== this.props.message || theme !== this.props.theme)) {
        this.renderLoading(nextProps);
        if (active) {
          this.display(active);
        }
      }

      // show/hide box;
      if (active !== this.props.active || button !== this.props.button) {
        // when button changed, restore previous button state;
        if (button !== this.props.button && this.props.active) {
          if (this.props.button !== undefined) {
            this.props.button.classList.remove('disabled');
          }
          if (this.props.button !== undefined) {
            this.props.button.removeAttribute('disabled');
          }
        }
        this.display(active, button);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          active = _props.active,
          masked = _props.masked,
          button = _props.button;
      var container = this.props.container;
      // console.log('didMount props', this.props);
      // initial container

      if (container == undefined) {
        // eslint-disable-line eqeqeq
        container = this.getContainer();
      }
      if (container instanceof HTMLElement) {
        this.createLoadingBox(container, masked);
        this.renderLoading(this.props);
      }

      this.display(active, button);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.box) {
        this.destroy();
      }
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      // clear
      (0, _reactDom.unmountComponentAtNode)(this.box);
      if (this.box && this.box.parentNode) {
        this.box.parentNode.removeChild(this.box);
        this.box = null;
      }
    }
    // nothing to render; done manually into container;

  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('i', null); // necessary for findDOMNode;
    }
  }]);

  return LocalLoading;
}(_react.PureComponent);

LocalLoading.defaultProps = {
  masked: false,
  theme: _themes.Blobs
};
exports.default = LocalLoading;