var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { render as _render } from 'react-dom';
import { Spinning } from './themes';
import styles from './styles';

export var GlobalLoadingComp = function (_Component) {
  _inherits(GlobalLoadingComp, _Component);

  function GlobalLoadingComp() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GlobalLoadingComp);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GlobalLoadingComp.__proto__ || Object.getPrototypeOf(GlobalLoadingComp)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      shown: false,
      messages: {}
    }, _this.loadingCount = 0, _this.clickHandler = function () {
      if (_this.props.masked && _this.props.closable) {
        _this.setState({ shown: false });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GlobalLoadingComp, [{
    key: 'addLoading',
    // multiple loadings may be pending meantime;

    value: function addLoading(msg) {
      this.loadingCount++;
      var id = GlobalLoadingComp.generateID();
      var newState = { shown: true, messages: {} };
      if (msg) {
        newState.messages = _extends({}, this.state.messages, _defineProperty({}, id, msg));
      }
      this.setState(newState);
      return id;
    }
  }, {
    key: 'removeLoading',
    value: function removeLoading(id) {
      // console.log('remove loading', id);
      this.loadingCount--;
      if (this.loadingCount < 0) {
        // unknown exception;
        // console.error('loading removed more than once', id);
        this.loadingCount = 0;
      }
      delete this.state.messages[id];
      this.setState({ shown: !!this.loadingCount, messages: this.state.messages });
    }
  }, {
    key: 'render',
    value: function render() {
      var CTheme = this.props.theme || Spinning;
      var msgs = this.state.messages;
      var msgList = Object.keys(this.state.messages).length ? React.createElement(
        'ul',
        { className: styles.messageList },

        // {Object.entries(this.state.messages).map(([k, v]) => <li key={k}>{v}</li>)}
        Object.keys(msgs).map(function (k) {
          return React.createElement(
            'li',
            { key: k },
            msgs[k]
          );
        })
      ) : '';
      // console.log('msgList', msgList);
      return React.createElement(
        'div',
        {
          className: this.props.masked ? styles.globalMasked : styles.global,
          style: { visibility: this.state.shown ? 'visible' : 'hidden' },
          onClick: this.clickHandler
        },
        React.createElement(CTheme, { message: msgList })
      );
    }
  }], [{
    key: 'generateID',
    value: function generateID() {
      return 'loading' + new Date().valueOf() + Math.round(Math.random() * 10000);
    }
  }]);

  return GlobalLoadingComp;
}(Component);

/**
 * Class GlobalLoading.
 * This class is singleton internally, But could be created more than once.
 * Exactly that is the only correct way to change the global loading signal styles on the fly.
 */
GlobalLoadingComp.defaultProps = {
  theme: Spinning,
  masked: false,
  closable: false // if the signal can be closed by clicking the mask;
};

var GlobalLoading = function () {
  _createClass(GlobalLoading, null, [{
    key: 'getInstance',

    /**
     * **static**
     * Retrieve the GlobalLoading singleton instance.
     * @returns {instance}
     */
    value: function getInstance() {
      return this.singleInst;
    }
  }]);

  /**
   * @param {React.ComponentType<*>} [theme=Spinning] - Customized theme.
   * @param {bool} [masked=false] - Whether to display overlay below.
   * @param {bool} [closable=false] - Whether the signal can be closed by clicking the mask.
   * @returns {this} - A singleton instance
   */
  function GlobalLoading(theme, masked, closable) {
    _classCallCheck(this, GlobalLoading);

    if (this.constructor.singleInst) {
      // singleton: mount global once for ever; but still update its properties;
      this.constructor.singleInst.render(theme, masked, closable);
      return this.constructor.singleInst;
    }
    this.constructor.singleInst = this;

    this.root = document.createElement('div');
    this.root.style.position = 'relative';
    this.render(theme, masked, closable);
    if (!document.body) throw new Error('Please instantiate GlobalLoading after document.body is accessible');
    document.body.appendChild(this.root);
  }

  _createClass(GlobalLoading, [{
    key: 'render',
    value: function render(theme, masked, closable) {
      this.Comp = _render(React.createElement(GlobalLoadingComp, { theme: theme, masked: masked, closable: closable }), this.root);
    }
    /**
     * Open global loading signal
     * @param {React.Node} [msg] - Message to show. (React.Node: anything React can render.)
     * @returns {Indicator} - An identifier for this signal, ignoring its internal structure.
     */

  }, {
    key: 'open',
    value: function open(msg) {
      var _this2 = this;

      // wait for local loading to handle,
      var idLoading = new Promise(function (resolve, reject) {
        window.setTimeout(function () {
          if (idLoading._canceled) {
            // bypass this loading, and reset flag;
            reject();
          } else {
            resolve(_this2.Comp.addLoading(msg));
          }
        }, 10);
      });
      idLoading.catch(function () {
        // console.log('global loading bypassed');
      }); // prevent error bubbling up;
      return idLoading;
    }
    /**
     * Close a signal
     * @param {Indicator} idLoading - The identifier returned by open().
     * @returns {void}
     */

  }, {
    key: 'close',
    value: function close(idLoading) {
      var _this3 = this;

      if (!idLoading) return;
      idLoading.then(function (id) {
        _this3.Comp.removeLoading(id);
      }, function () {});
    }
  }]);

  return GlobalLoading;
}();

export default GlobalLoading;