import React from 'react';
import styles from '../styles';

function defaultCaption(progress) {
  return 'progress: ' + (progress * 100).toPrecision(4) + '%';
}

export default function LoadingProgress(_ref) {
  var message = _ref.message,
      caption = _ref.caption;

  return React.createElement(
    'div',
    { className: styles.progress },
    React.createElement(
      'div',
      null,
      caption && caption(message)
    ),
    React.createElement(
      'div',
      { className: styles.progressBar },
      React.createElement('div', { style: { width: message * 100 + '%' } })
    )
  );
}

LoadingProgress.defaultProps = {
  caption: defaultCaption
};